//First the first
Importer.loadQtBinding( "qt.core" );
Importer.loadQtBinding( "qt.gui" );
Importer.include("firstRun.js");

checkTimer = new QTimer(this);
checkTimer.timeout.connect(checkTimes);
checkTimer.start(60*1000, false);

//This is where the alarms live
var alarms = new Array();

function checkTimes(){
	 for(i=0;i<alarms.length;i++){
		  //Current Alarm
		  ca = alarms[i];
		  refreshVars(ca);

		  if(ca.enabled){
			   offset = ca.time.secsTo(QTime.currentTime())
			   if( offset<=0 && Math.abs(offset) <= 60){
					i = Math.abs(offset);
					if(ca.statusTimer!=null)
						 return;

					ca.statusTimer = new QTimer(this);
					ca.statusTimer.timeout.connect(function(){
						 if(i>=0){
							  ca.ui.statusText.text = i--+"s to start"
						 }else{
							  ca.statusTimer.stop();
						 }
					});
					ca.statusTimer.start(1000, false);
					ca.fireTimer = new QTimer(this);
					ca.fireTimer.timeout.connect({alarm:ca},prepareFade);
					ca.fireTimer.start(Math.abs( ca.time.msecsTo(QTime.currentTime()) ), true);
			   }else if(ca.statusTimer!=null){
					ca.statusTimer.stop();
					ca.statusTimer=null;
					setStatus(ca,1)
			   }
		  }
     }
}

function prepareFade(){
	 refreshVars(this.alarm)

	 Amarok.Engine.volume = this.alarm.keep_vol?Amarok.Engine.volume:this.alarm.init_vol;
	 Amarok.Engine.Play();
	 direction = true;
	 if(Amarok.Engine.volume>this.alarm.final_vol)
		  direction = false;

	 secs = this.alarm.transition*60;
	 vol_offset = Amarok.Engine.volume-this.alarm.final_vol;
	 interval = (secs*1000)/(Math.abs(vol_offset)/4)
	 if(this.alarm.fadeTimer!=null)
		  return;

	 setStatus(this.alarm, 2);
	 if(this.alarm.transition>0){
		  this.alarm.fadeTimer = new QTimer(this);
		  this.alarm.fadeTimer.timeout.connect({alarm:this.alarm,direction:direction}, doFade);
		  this.alarm.fadeTimer.start(interval, false);
	 }else{
		  Amarok.Engine.volume = this.alarm.final_vol
		  if(this.alarm.final_vol==0){
			   Amarok.Engine.Stop();
		  }
		  setStatus(this.alarm, 1)
	 }
}

function doFade(){
	 if(this.direction)
		  Amarok.Engine.IncreaseVolume(4);
	 else
		  Amarok.Engine.DecreaseVolume(4);

	 if( (!this.direction && Amarok.Engine.volume<=this.alarm.final_vol) || (this.direction && Amarok.Engine.volume>=this.alarm.final_vol) || (Amarok.Engine.volume==this.alarm.final_vol) ){

		  setStatus(this.alarm,1)

		  if(Amarok.Engine.volume==0)
			   Amarok.Engine.Stop()
	}
}

function setStatus(alarm,status){
	 switch(status){
		  case 1:
			   alarm.status = 1;
			   if(alarm.fadeTimer != null){
					alarm.fadeTimer.stop()
					alarm.fadeTimer=null;
			   }
			   alarm.ui.statusText.text = "Idle"
			   alarm.ui.timeL.enabled = true;
			   alarm.ui.init_volL.enabled = !alarm.ui.keep_vol.checked;
			   alarm.ui.final_volL.enabled = true;
			   alarm.ui.keep_volL.enabled = true;
			   alarm.ui.transitionL.enabled = true;

			   alarm.ui.time.enabled = true;
			   alarm.ui.init_vol.enabled = !alarm.ui.keep_vol.checked;
			   alarm.ui.final_vol.enabled = true;
			   alarm.ui.keep_vol.enabled = true;
			   alarm.ui.transition.enabled = true;
			   alarm.ui.stopb.enabled = false;
		  break;
		  case 2:
			   alarm.status = 2;

			   if(alarm.statusTimer!=null){
					alarm.statusTimer.stop();
					alarm.statusTimer=null;
			   }

			   alarm.ui.statusText.text = "Running"
			   alarm.ui.timeL.enabled = false;
			   alarm.ui.init_volL.enabled = false;
			   alarm.ui.final_volL.enabled = false;
			   alarm.ui.keep_volL.enabled = false;
			   alarm.ui.transitionL.enabled = false;
			   alarm.ui.time.enabled = false;
			   alarm.ui.init_vol.enabled = false;
			   alarm.ui.final_vol.enabled = false;
			   alarm.ui.keep_vol.enabled = false;
			   alarm.ui.transition.enabled = false;
			   alarm.ui.stopb.enabled = true;
		  break;
	 }
}


function readSettings(alarm){
	 alarm.ui.checked = Amarok.Script.readConfig("alarm_"+alarm.name+"_enabled","false")=="false"?false:true;
	 alarm.ui.time.time 		= 	QTime.fromString(Amarok.Script.readConfig("alarm_"+alarm.name+"_time","00:00"),"hh:mm");
	 alarm.ui.init_vol.value 	=	parseInt(Amarok.Script.readConfig("alarm_"+alarm.name+"_init_vol","0"));
	 alarm.ui.keep_vol.checked	=	Amarok.Script.readConfig("alarm_"+alarm.name+"_keep_vol","false")=="false"?false:true;
	 alarm.ui.final_vol.value	=	parseInt(Amarok.Script.readConfig("alarm_"+alarm.name+"_final_vol","0"));
	 alarm.ui.transition.value	=	parseInt(Amarok.Script.readConfig("alarm_"+alarm.name+"_transition","0"));
	 refreshVars(alarm);
}

function saveSettings(alarm){
	 refreshVars(alarm);
	 Amarok.Script.writeConfig("alarm_"+alarm.name+"_enabled",alarm.enabled?"true":"false")
	 Amarok.Script.writeConfig("alarm_"+alarm.name+"_time",alarm.time.toString("hh:mm"))
	 Amarok.Script.writeConfig("alarm_"+alarm.name+"_init_vol",alarm.init_vol.toString())
	 Amarok.Script.writeConfig("alarm_"+alarm.name+"_keep_vol",alarm.keep_vol?"true":"false")
	 Amarok.Script.writeConfig("alarm_"+alarm.name+"_final_vol",alarm.final_vol.toString())
	 Amarok.Script.writeConfig("alarm_"+alarm.name+"_transition",alarm.transition.toString())
}

function drawUI(alarm){
	 a = new QGroupBox();
	 l = new QFormLayout(a);
	 l.fieldGrowthPolicy = QFormLayout.ExpandingFieldsGrow;
	 a.title = "Alarm "+alarm.name;
	 a.checkable = true;
	 a.checked = false;

	 //Start Time
	 l.setWidget(0,QFormLayout.LabelRole, timeL = new QLabel("Alarm Time"))
	 timeL.objectName = "timeL"
	 t = new QTimeEdit();
	 t.objectName="time";

	 t.setSizePolicy(QSizePolicy.MinimumExpanding, QSizePolicy.Fixed);
	 l.setWidget(0,QFormLayout.FieldRole, t)

	 //Initial Volume
	 l.setWidget(1,QFormLayout.LabelRole, init_volL = new QLabel("Initial volume"))
	 init_volL.objectName = "init_volL"
	 g = new QSlider();
	 g.objectName="init_vol";
	 g.orientation = Qt.Horizontal;
	 g.maximum=100;
	 g.setSizePolicy(QSizePolicy.MinimumExpanding, QSizePolicy.Fixed);
	 l.setWidget(1,QFormLayout.FieldRole, g)

	 //Keep Volume as is
	 l.setWidget(2,QFormLayout.LabelRole, keep_volL= new QLabel("Keep volume as it is"))
	 keep_volL.objectName = "keep_volL"
	 keep_volL.wordWrap = true;
	 f = new QCheckBox();
	 f.objectName = "keep_vol"
	 f.setSizePolicy(QSizePolicy.MinimumExpanding, QSizePolicy.Fixed);
	 l.setWidget(2,QFormLayout.FieldRole, f)
	 f.toggled.connect({g:g,gl:init_volL},function(value){
		  this.gl.enabled = !value;
		  this.g.enabled = !value;
	 })

	 //Final Volume
	 l.setWidget(3,QFormLayout.LabelRole, final_volL = new QLabel("Final volume"))
	 final_volL.objectName = "final_volL"
	 h = new QSlider();
	 h.objectName="final_vol";
	 h.orientation = Qt.Horizontal;
	 h.maximum=100;
	 h.setSizePolicy(QSizePolicy.MinimumExpanding, QSizePolicy.Fixed);
	 l.setWidget(3,QFormLayout.FieldRole, h)

	 l.setWidget(4,QFormLayout.LabelRole, transitionL = new QLabel("Time to reach final volume"))
	 transitionL.objectName = "transitionL"
	 transitionL.wordWrap = true;
	 u = new QSpinBox();
	 u.objectName="transition";
	 u.maximum=3600;
	 u.suffix = " Minutes"
	 u['valueChanged(int)'].connect({u:u},function(value){this.u.suffix = value==1?" Minute":" Minutes"})
	 u.setSizePolicy(QSizePolicy.MinimumExpanding, QSizePolicy.Fixed);
	 l.setWidget(4,QFormLayout.FieldRole, u)

	 l.setWidget(5,QFormLayout.LabelRole, statusTextL = new QLabel("Status"))
	 vb = new QVBoxLayout();
	 vb.addWidget(b = new QLabel("Idle"),0,1)
	 b.alignment = Qt.AlignCenter;
	 b.objectName = "statusText"
	 vb.addWidget(r = new QPushButton("Stop Alarm"),0,1)
	 r.objectName="stopb";
	 r.setSizePolicy(QSizePolicy.MinimumExpanding, QSizePolicy.Fixed);
	 l.setLayout(5,QFormLayout.FieldRole, vb)

	 //Stop alarm!
	 r.clicked.connect(function(){
		  setStatus(alarm,1)
	 })

	 //Disable stop button
	 a.toggled.connect(function(value){
		  setStatus(alarm,1);
		  if(alarm.status!=2)
			   alarm.ui.stopb.enabled = false;
	 })

	 return a;
}

function refreshVars(alarm){
	 alarm.enabled = alarm.ui.checked
	 alarm.time = alarm.ui.time.time
	 alarm.init_vol = alarm.ui.init_vol.value
	 alarm.keep_vol = alarm.ui.keep_vol.checked
	 alarm.final_vol = alarm.ui.final_vol.value
	 alarm.transition = alarm.ui.transition.value
}

function Alarm(name){
	 this.name = name;
	 this.status;
	 this.ui = drawUI(this)
	 this.fadeTimer = null;
	 this.statusTimer = null;
	 //Add the alarm to the array
	 alarms.push(this)
	 //Try to restore settings automatically
	 readSettings(this)
	 //Add only now that the value has been restored
	 this.ui.time.timeChanged.connect(function(){
		  checkTimes();
	 })

}

// Create the main window
obj = new QWidget(this)

obj.windowTitle = "Configure Alarm";
vLayout = new QVBoxLayout(obj);
hLayout = new QHBoxLayout();
vLayout.addLayout(hLayout);

//Create the two alarms
alarm1 = new Alarm(1);
alarm2 = new Alarm(2);
//Finish setting up the window
hLayout.addWidget(alarm1.ui,0,1)
hLayout.addWidget(alarm2.ui,0,1)

buttonBox = new QDialogButtonBox(obj);
buttonBox.orientation = Qt.Horizontal;
buttonBox.centerButtons = false;
buttonBox.addButton(close = QDialogButtonBox.Cancel);
buttonBox.addButton(save = QDialogButtonBox.Save);
vLayout.insertWidget(1,buttonBox,Qt.vertical);

buttonBox.buttons()[0].clicked.connect(function(){
	 for(i=0;i<alarms.length;i++){
		  saveSettings(alarms[i])
	 }
	 Amarok.alert("Settings Saved!")
})

buttonBox.rejected.connect(function(){obj.close()})

function onConfigure(){
     obj.show();
}

Amarok.Window.addSettingsMenu( "configalarm", "Configure Alarm", "preferences-desktop-notification-bell");
Amarok.Window.SettingsMenu.configalarm['triggered()'].connect( onConfigure );

//Check times to start with
checkTimes();